﻿Public Class Form1

    Const BUF_SIZE As Integer = 300

    Const BVCM_BILL As Integer = 0
    Const BVCM_COIN As Integer = 1

    Const BVCM_OK As Integer = 0
    Const BVCM_INVALID_HANDLE As Integer = 1
    Const BVCM_IO_ERROR As Integer = 2
    Const BVCM_INVALID_PARAMETER As Integer = 3
    Const BVCM_NO_RESPONSE As Integer = 4
    Const BVCM_OTHER_ERROR As Integer = 5
    Const BVCM_ACK1 As Integer = 6
    Const BVCM_ACK2 As Integer = 7
    Const BVCM_ACK3 As Integer = 8
    Const BVCM_ACK4 As Integer = 9
    Const BVCM_NAK As Integer = 10
    Const BVCM_BUSY As Integer = 11

    Private Declare Function ScanIF Lib "bvcm.dll" Alias "?BVCM_ScanInterface@@YGKPAI@Z" (ByRef puiNumber As Integer) As Integer
    Private Declare Function OpenIF Lib "bvcm.dll" Alias "?BVCM_OpenInterface@@YGKIPAPAX@Z" (ByVal uiInterface As Integer, ByRef bvcmHandle As Integer) As Integer
    Private Declare Function CloseIF Lib "bvcm.dll" Alias "?BVCM_CloseInterface@@YGKPAX@Z" (ByVal bvcmHandle As Integer) As Integer
    Private Declare Function Stby Lib "bvcm.dll" Alias "?BVCM_Standby@@YGKPAXI@Z" (ByVal bvcmHandle As Integer, ByVal iTarget As Integer) As Integer
    Private Declare Function GetAllDt Lib "bvcm.dll" Alias "?BVCM_GetAllData@@YGKPAXIPADI@Z" (ByVal bvcmHandle As Integer, ByVal iTarget As Integer, ByVal pcBuffer() As Byte, ByVal iBufferSize As Integer) As Integer
    Private Declare Function GetDt Lib "bvcm.dll" Alias "?BVCM_GetData@@YGKPAXIPADI@Z" (ByVal bvcmHandle As Integer, ByVal iTarget As Integer, ByVal pcBuffer() As Byte, ByVal iBufferSize As Integer) As Integer
    Private Declare Function PutDt Lib "bvcm.dll" Alias "?BVCM_PutData@@YGKPAXIPAD@Z" (ByVal bvcmHandle As Integer, ByVal iTarget As Integer, ByVal pcBuffer() As Byte) As Integer
    Private Declare Function LnReset Lib "bvcm.dll" Alias "?BVCM_LineReset@@YGKPAX@Z" (ByVal bvcmHandle As Integer) As Integer

    Dim ifNumber As Integer                     'インターフェース数
    Dim ifHndl As Integer                       'インターフェースハンドル
    Dim existsCM As Integer
    Dim existsBV As Integer
    Dim enableCM As Integer
    Dim enableBV As Integer

    Dim cash_10 As Integer
    Dim cash_50 As Integer
    Dim cash_100 As Integer
    Dim cash_500 As Integer
    Dim cash_1000 As Integer

    Dim change_10 As Integer
    Dim change_50 As Integer
    Dim change_100 As Integer
    Dim change_500 As Integer
    Dim change_1000 As Integer

    Dim paid_10 As Integer
    Dim paid_50 As Integer
    Dim paid_100 As Integer
    Dim paid_500 As Integer
    Dim paid_1000 As Integer

    Dim coinStat As Integer
    Dim coinErr1 As Integer
    Dim coinErr2 As Integer
    Dim coinVer1 As Integer
    Dim coinVer2 As Integer

    Dim billStat1 As Integer
    Dim billStat2 As Integer
    Dim billErr As Integer
    Dim billVer1 As Integer
    Dim billVer2 As Integer

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim stc As Integer                          'ステータスコード
        Dim buf(BUF_SIZE) As Byte

        TextBox1.Text = 0
        TextBox2.Text = 0
        TextBox3.Text = 0
        TextBox4.Text = 0
        TextBox5.Text = 0

        enableBV = False
        enableCM = False

        stc = ScanIF(ifNumber)                  'インターフェースをスキャン
        If (ifNumber > 0) Then
            stc = OpenIF(0, ifHndl)             '最初のインターフェースをオープン
            If (stc = BVCM_OK) And (ifHndl <> 0) Then

                stc = Stby(ifHndl, BVCM_BILL)   'ビルバリスタンバイ
                If (stc = BVCM_ACK1) Then
                    existsBV = True
                Else
                    existsBV = False
                End If

                stc = Stby(ifHndl, BVCM_COIN)   'コインメックスタンバイ
                If (stc = BVCM_ACK1) Then
                    existsCM = True
                Else
                    existsCM = False
                End If

            End If
        End If

        If (existsBV = True) Then
            stc = GetAllDt(ifHndl, BVCM_BILL, buf, BUF_SIZE)
            If (stc = BVCM_ACK1) Then
                ParseData2(BVCM_BILL, buf)
            End If
        End If

        If (existsCM = True) Then
            stc = GetAllDt(ifHndl, BVCM_COIN, buf, BUF_SIZE)
            If (stc = BVCM_ACK1) Then
                ParseData2(BVCM_BILL, buf)
            End If
        End If

        Timer1.Enabled = True

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim stc As Integer
        Dim buf(BUF_SIZE) As Byte

        If (existsBV = True) Then
            stc = GetDt(ifHndl, BVCM_BILL, buf, BUF_SIZE)
            If (stc = BVCM_ACK2) Then
                ParseData1(BVCM_BILL, buf, 1)
            ElseIf (stc = BVCM_ACK3) Then
                ParseData2(BVCM_BILL, buf)
            End If
        End If

        If (existsCM = True) Then
            stc = GetDt(ifHndl, BVCM_COIN, buf, BUF_SIZE)
            If (stc = BVCM_ACK2) Then
                ParseData1(BVCM_COIN, buf, 1)
            ElseIf (stc = BVCM_ACK3) Then
                ParseData2(BVCM_COIN, buf)
            End If
        End If

        TextBox1.Text = cash_10
        TextBox2.Text = cash_50
        TextBox3.Text = cash_100
        TextBox4.Text = cash_500
        TextBox5.Text = cash_1000

    End Sub

    Private Sub ParseData1(ByVal iTarget As Integer, ByVal buf() As Byte, ByVal ptr As Integer)

        Dim dc As Integer

        If (iTarget = BVCM_COIN) Then

            dc = buf(ptr + 1)

            Select Case dc

                Case &H8
                    cash_10 = BcdToInt(buf(ptr + 2))
                    cash_50 = BcdToInt(buf(ptr + 3))
                    cash_100 = BcdToInt(buf(ptr + 4))
                    cash_500 = BcdToInt(buf(ptr + 5))

                Case &H9
                    change_10 = BcdToInt(buf(ptr + 2))
                    change_50 = BcdToInt(buf(ptr + 3))
                    change_100 = BcdToInt(buf(ptr + 4))
                    change_500 = BcdToInt(buf(ptr + 5))

                Case &HA
                    paid_10 = BcdToInt(buf(ptr + 2))
                    paid_50 = BcdToInt(buf(ptr + 3))
                    paid_100 = BcdToInt(buf(ptr + 4))
                    paid_500 = BcdToInt(buf(ptr + 5))

                Case &HB
                    coinStat = BcdToInt(buf(ptr + 2))

                Case &HC
                    coinErr1 = BcdToInt(buf(ptr + 2))
                    coinErr2 = BcdToInt(buf(ptr + 3))

                Case &HD
                    coinVer1 = BcdToInt(buf(ptr + 2))
                    coinVer2 = BcdToInt(buf(ptr + 3))

            End Select

        ElseIf (iTarget = BVCM_BILL) Then

            dc = buf(ptr + 1)

            Select Case dc

                Case &H18
                    cash_1000 = BcdToInt(buf(ptr + 2))

                Case &H19
                    change_1000 = BcdToInt(buf(ptr + 2))

                Case &H1A
                    paid_1000 = BcdToInt(buf(ptr + 2))

                Case &H1B
                    billStat1 = BcdToInt(buf(ptr + 2))
                    billStat2 = BcdToInt(buf(ptr + 3))

                Case &H1D
                    billVer1 = BcdToInt(buf(ptr + 2))
                    billVer2 = BcdToInt(buf(ptr + 3))

            End Select

        End If

    End Sub

    Private Sub ParseData2(ByVal iTarget As Integer, ByVal buf() As Byte)

        Dim allbytes As Integer
        Dim partbytes As Integer
        Dim i As Integer

        allbytes = buf(1) + 1
        i = 2
        While (i <= allbytes)
            partbytes = buf(i)
            ParseData1(iTarget, buf, i)
            i = i + partbytes + 1
        End While

    End Sub

    Private Function BcdToInt(ByVal bcd As Byte) As Integer

        Dim tmp As Integer

        tmp = ((bcd And &HF0) / 16) * 10
        tmp = tmp + (bcd And &HF)

        Return tmp

    End Function

    Private Function IntToBcd(ByVal value As Integer) As Byte

        Dim tmp As Byte
        Dim dv, md As Integer

        If (value > 99) Then
            tmp = &H99
        Else
            dv = value / 10
            md = value Mod 10
            tmp = (dv * 16) + md
        End If

        Return tmp

    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim stc As Integer
        Dim buf(5) As Byte
        Dim tmp As Byte

        If (existsBV = True) Then
            If (enableBV = False) Then
                buf(0) = 3              ' bytes
                tmp = buf(0)
                buf(1) = &H10           ' data command
                tmp = tmp Xor buf(1)
                buf(2) = &H31           ' data1
                tmp = tmp Xor buf(2)
                buf(3) = &H0            ' data2
                tmp = tmp Xor buf(3)
                buf(4) = tmp            ' fcc
                stc = PutDt(ifHndl, BVCM_BILL, buf)
                If (stc = BVCM_ACK1) Then
                    enableBV = True
                    Button1.Text = "受入停止"
                    Button2.Enabled = False
                    Button3.Enabled = False
                End If
            Else
                buf(0) = 3              ' bytes
                tmp = buf(0)
                buf(1) = &H10           ' data command
                tmp = tmp Xor buf(1)
                buf(2) = &H30           ' data1
                tmp = tmp Xor buf(2)
                buf(3) = &H0            ' data2
                tmp = tmp Xor buf(3)
                buf(4) = tmp            ' fcc
                stc = PutDt(ifHndl, BVCM_BILL, buf)
                If (stc = BVCM_ACK1) Then
                    enableBV = False
                    Button1.Text = "受入開始"
                    Button2.Enabled = True
                    Button3.Enabled = True
                End If
            End If
        End If

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        Dim stc As Integer
        Dim buf(7) As Byte
        Dim tmp As Byte

        If (existsBV = True) Then
            buf(0) = 5                  ' bytes
            tmp = buf(0)
            buf(1) = &H11               ' data command
            tmp = tmp Xor buf(1)
            buf(2) = &H0
            tmp = tmp Xor buf(2)
            buf(3) = IntToBcd(cash_1000) << 4
            tmp = tmp Xor buf(3)
            buf(4) = &H0
            tmp = tmp Xor buf(4)
            buf(5) = &H0
            tmp = tmp Xor buf(5)
            buf(6) = tmp                ' fcc
            stc = PutDt(ifHndl, BVCM_BILL, buf)
            If (stc = BVCM_ACK1) Then
                buf(0) = 3              ' bytes
                tmp = buf(0)
                buf(1) = &H10           ' data command
                tmp = tmp Xor buf(1)
                buf(2) = &H32           ' 挿入金クリア
                tmp = tmp Xor buf(2)
                buf(3) = &H0
                tmp = tmp Xor buf(3)
                buf(4) = tmp            ' fcc
                stc = PutDt(ifHndl, BVCM_BILL, buf)
            End If
        End If

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click

        Dim stc As Integer
        Dim buf(5) As Byte
        Dim tmp As Byte

        If (existsBV = True) Then
            buf(0) = 3                  ' bytes
            tmp = buf(0)
            buf(1) = &H10               ' data command
            tmp = tmp Xor buf(1)
            buf(2) = &H32               ' 収金
            tmp = tmp Xor buf(2)
            buf(3) = &H0
            tmp = tmp Xor buf(3)
            buf(4) = tmp                ' fcc
            stc = PutDt(ifHndl, BVCM_BILL, buf)
        End If

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click

        Dim stc As Integer
        Dim buf(4) As Byte
        Dim tmp As Byte

        If (existsCM = True) Then
            If (enableCM = False) Then
                buf(0) = 2              ' bytes
                tmp = buf(0)
                buf(1) = &H0            ' data command
                tmp = tmp Xor buf(1)
                buf(2) = &H1            ' data
                tmp = tmp Xor buf(2)
                buf(3) = tmp            ' fcc
                stc = PutDt(ifHndl, BVCM_COIN, buf)
                If (stc = BVCM_ACK1) Then
                    enableCM = True
                    Button4.Text = "受入停止"
                    Button5.Enabled = False
                    Button6.Enabled = False
                End If
            Else
                buf(0) = 2              ' bytes
                tmp = buf(0)
                buf(1) = &H0            ' data command
                tmp = tmp Xor buf(1)
                buf(2) = &H0            ' data
                tmp = tmp Xor buf(2)
                buf(3) = tmp            ' fcc
                stc = PutDt(ifHndl, BVCM_COIN, buf)
                If (stc = BVCM_ACK1) Then
                    enableCM = False
                    Button4.Text = "受入開始"
                    Button5.Enabled = True
                    Button6.Enabled = True
                End If
            End If
        End If

    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click

        Dim stc As Integer
        Dim buf(6) As Byte
        Dim tmp As Byte
        Dim cash, d10, d100, d1000, d10000 As Integer

        If (existsCM = True) Then
            buf(0) = 4                  ' bytes
            tmp = buf(0)
            buf(1) = &H1                ' data command
            tmp = tmp Xor buf(1)
            cash = (cash_500 * 500) + (cash_100 * 100) + (cash_50 * 50) + (cash_10 * 10)
            d10000 = Int(cash / 10000)
            d1000 = Int((cash Mod 10000) / 1000)
            d100 = Int((cash - (d10000 * 10000) - (d1000 * 1000)) / 100)
            d10 = Int((cash - (d10000 * 10000) - (d1000 * 1000) - (d100 * 100)) / 10)
            buf(2) = d10 << 4
            tmp = tmp Xor buf(2)
            buf(3) = (d1000 << 4) + d100
            tmp = tmp Xor buf(3)
            buf(4) = d10000
            tmp = tmp Xor buf(4)
            buf(5) = tmp                ' fcc
            stc = PutDt(ifHndl, BVCM_COIN, buf)
            If (stc = BVCM_ACK1) Then
                buf(0) = 2              ' bytes
                tmp = buf(0)
                buf(1) = &H0            ' data command
                tmp = tmp Xor buf(1)
                buf(2) = &H2            ' 挿入金クリア
                tmp = tmp Xor buf(2)
                buf(3) = tmp            ' fcc
                stc = PutDt(ifHndl, BVCM_COIN, buf)
            End If
        End If

    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click

        Dim stc As Integer
        Dim buf(4) As Byte
        Dim tmp As Byte

        If (existsCM = True) Then
            buf(0) = 2              ' bytes
            tmp = buf(0)
            buf(1) = &H0            ' data command
            tmp = tmp Xor buf(1)
            buf(2) = &H2            ' 挿入金クリア
            tmp = tmp Xor buf(2)
            buf(3) = tmp            ' fcc
            stc = PutDt(ifHndl, BVCM_COIN, buf)
        End If

    End Sub
End Class
